package WebFlow.ToolBar;

//import VTKModel;
import vtk.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.FileInputStream;
import java.net.URL;

import vtk.vtkVolumeRayCastCompositeFunction;

import WebFlow.*;
import WebFlow.RemoteFile.*;
import WebFlow.RemoteFile.RemoteFilePackage.*;
import extensions.generic.FileTransferBean;

public class App2flux extends Applet {
    VTKModel md;
    String mdname = null;
    String message = null;
  String filepath = null;

    vtkPanel panel = null;

  String urlfile="http://birch.csit.fsu.edu:8001/GOW/IOR/master.txt";
  String masterIOR;
  public org.omg.CORBA.ORB orb;
  public WebFlowContext master=null;
  org.omg.CORBA.Object obj;
  RemoteFile rf;
  FileTransferBean ftb;

  public App2flux(String filepath) {
    this.filepath = filepath;    
  }

    public static void main(String args[]) {

      /*
      Frame tempframe = new Frame("VTK Java Demo");     
	  App2 applet = new  App2();
      tempframe.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                        System.exit(0);
                }
      });
      tempframe.add(applet,BorderLayout.CENTER);
      tempframe.setSize(500,600);
      applet.init();
      applet.start();
      tempframe.setVisible(true);
      */
    }

    public void testme ()
      {
      //System.out.println("Starting Render");
      }


  

    public void init()
      {        
    //Connect to the master
    masterIOR=WebFlow.ClientUtils.getIORFromURL(urlfile);
    orb=WebFlow.ClientUtils.initializeORB(masterIOR,orb);
    master=WebFlow.ClientUtils.getMasterServer(masterIOR,orb);

    //Instatiate some webflow objects
    obj=WebFlow.ClientUtils.makeModule(master,"RemoteFile");
    rf=RemoteFileHelper.narrow(obj);
    rf.test();
    short blocksize = 10240;
    rf.setBlockSize(blocksize);
    ftb = new FileTransferBean(rf);

      GridBagLayout grid = new GridBagLayout();
      
      this.setLayout(grid);

      panel = new vtkPanel();
      panel.setSize(400,400);
      constrain(this,panel,0,0,8,8);
      
      FileInputStream is = null;
      try  {
	  //  *******************************************
	  //  HERE YOU HAVE TO CHANGE THE SOURCE
	  //*********************************************
	  /* 	mdname = "kitchen.vtk";
		
		is = new FileInputStream(mdname);
		md = new VTKModel(is);
		
		// create the model
		//	pr = new vtkPolyDataReader();
		pr = new vtkStructuredGridReader();	
		pr.ReadFromInputStringOn();
		pr.SetInputString(md.GetData());
		
		pr.Update();
	   */
	  
	  // Read the data from a vtk file
	  vtkStructuredPointsReader reader = new vtkStructuredPointsReader();

          /*
          mdname = filepath;
          byte buffer[] = null;
        String vtkdata = null;
        StringBuffer sb = new StringBuffer();

        try {
          rf.open(mdname,"r");
          buffer = rf.getBlock();
          String vtkdata1 = new String(buffer);
          sb.append(vtkdata1);

          while(true) {
            if(buffer.length > 0) {
              buffer = rf.getBlock();
              vtkdata1 = new String(buffer);
              sb.append(vtkdata1);
            }
            else throw new EOFFileException();
            System.out.println("Reading data: "+buffer.length);
          }
        } catch(EOFFileException ex) {
          rf.close();
        }

        vtkdata = sb.toString();
        */

	// create the model
	//	pr = new vtkPolyDataReader();
	//pr = new vtkStructuredGridReader();	
	//pr.ReadFromInputStringOn();
	//reader.ReadFromInputStringOn();
	//pr.SetInputString(md.GetData());
	//reader.SetInputString(vtkdata);

	//pr.SetFileName("plate.vtk");
          ftb.FileReceive("C:\\flux.vtk",filepath);
        reader.SetFileName("C:\\flux.vtk");
        reader.Update();
	 	  
	  //
	  // Create a transfer function mapping scalar value to opacity
	  //
	  int omin = 115;
	  int omax = 125;
	  
	  double opa = 1.0;
	  double opa2 = 0.1;
	  
	  
	  vtkPiecewiseFunction oTFun = new vtkPiecewiseFunction();
	  oTFun.AddSegment(0.0, 0.0, omin, 0.0);
	  oTFun.AddSegment(omin, opa, (omin+omax)/2, opa);
	  oTFun.AddSegment((omin+omax)/2, opa2, omax, opa2);
	  oTFun.AddSegment(omax, 0.0, 255, 0.0);
	  
	  // Create a transfer function mapping scalar value to color (RGB)

	  vtkColorTransferFunction cTFun = new vtkColorTransferFunction();
	  cTFun.AddRGBSegment(0,0.0,0.0,0.0,omin,0.0,0.0,0.0);
	  cTFun.AddRGBSegment(omin,1.0,0.0,0.0,(omin+omax)/2,1.0,0.0,0.0);
	  cTFun.AddRGBSegment((omin+omax)/2+1,0.0,0.0,1.0,omax,0.0,0.0,1.0);
	  cTFun.AddRGBSegment(omax,0.0,1.0,0.0,255,0.0,0.0,1.0);
	  
	  // Create a property for the volume and set the transfer functions.
	  // Turn shading on and use trilinear interpolation
	  vtkVolumeProperty volumeProperty = new vtkVolumeProperty();
	  volumeProperty.SetColor(cTFun);
	  volumeProperty.SetScalarOpacity(oTFun);
	  volumeProperty.SetInterpolationTypeToLinear();
	  volumeProperty.ShadeOn();
	  
	  // Create a ray function - this is a compositing ray function
	  vtkVolumeRayCastCompositeFunction compositeFunction =  new vtkVolumeRayCastCompositeFunction();
	  
	  // Create the volume mapper and set the ray function and scalar input
	  vtkVolumeRayCastMapper volumeMapper = new vtkVolumeRayCastMapper();
	  volumeMapper.SetInput(reader.GetOutput());
	  volumeMapper.SetVolumeRayCastFunction(compositeFunction);
	  
	  // Create the volume and set the mapper and property
	  vtkVolume volume = new vtkVolume();
	  volume.SetMapper(volumeMapper);
	  volume.SetProperty(volumeProperty);
	  
	  
	  //
	  // Create outline around data
	  //
	  //
	  vtkOutlineFilter outline = new vtkOutlineFilter();
	  outline.SetInput(reader.GetOutput());
	  
	  vtkPolyDataMapper outlineMapper = new vtkPolyDataMapper();
	  outlineMapper.SetInput(outline.GetOutput());
	  
	  vtkActor outlineActor = new vtkActor();
	  outlineActor.SetMapper(outlineMapper);
	  outlineActor.GetProperty().SetColor(1,1,1);
	  
	  panel.getRenderer().AddActor(outlineActor);
	  
	  panel.getRenderer().AddActor(volume);
	  panel.getRenderer().SetStartRenderMethod(this,"testme");
	  
	  
	  
	  vtkRenderWindowInteractor iren = new vtkRenderWindowInteractor();
	  iren.SetRenderWindow(panel.getRenderWindow());
	  iren.SetDesiredUpdateRate(3.0);
	  iren.SetStillUpdateRate(0.001);
	  iren.Start();
	  //panel.getRenderer().Start();
	  
      }
      catch(Exception e) 
	  {
	      e.printStackTrace();
	      md = null;
	      message = e.toString();
	  }
      try 
	  {
	      if (is != null) is.close();
	  } 
      catch(Exception e) 
	  {
	  }

      doLayout();	
      this.setBackground(new Color(120, 140, 160));
      setVisible(true); 
      }

    public void constrain(Container cont, Component comp,
                          int grid_x, int grid_y, 
                          int grid_width, int grid_height)
      {
      GridBagConstraints c = new GridBagConstraints();
      c.gridx = grid_x;
      c.gridy = grid_y;
      c.gridwidth = grid_width;
      c.gridheight = grid_height;
      c.anchor = GridBagConstraints.NORTH;

      ((GridBagLayout)cont.getLayout()).setConstraints(comp,c);
      cont.add(comp);
      }

}

