package WebFlow.ToolBar;

//import VTKModel;
import vtk.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.FileInputStream;
import java.net.URL;

import WebFlow.*;
//import org.omg.CORBA.*;
import WebFlow.RemoteFile.*;
import WebFlow.RemoteFile.RemoteFilePackage.*;
import extensions.generic.FileTransferBean;

public class App2kitchen extends Applet {
  VTKModel md;
  String mdname = null;
  String message = null;
  String filepath = null;  

  //vtkPolyDataReader pr = null;
  vtkStructuredGridReader pr = null;
  
  vtkWarpVector warp = null;
  vtkGeometryFilter ds2poly = null;
  vtkCleanPolyData clean = null;
  vtkPolyDataNormals normals = null;
  vtkVectorDot color = null;
  //    vtkDataSetMapper plateMapper = null;
  vtkPolyDataMapper plateMapper = null;
  vtkPanel panel = null;
  vtkActor a = null;

  String urlfile="http://birch.csit.fsu.edu:8001/GOW/IOR/master.txt";
  String masterIOR;
  public org.omg.CORBA.ORB orb;
  public WebFlowContext master=null;
  org.omg.CORBA.Object obj;
  RemoteFile rf;
  FileTransferBean ftb;

  public App2kitchen(String filepath) {
    this.filepath = filepath;
  }

    public static void main(String args[]) {

      /*
      Frame tempframe = new Frame("VTK Java Demo");     
	  App2 applet = new  App2();
      tempframe.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                        System.exit(0);
                }
      });
      tempframe.add(applet,BorderLayout.CENTER);
      tempframe.setSize(420,500);
      applet.init();
      applet.start();
      tempframe.setVisible(true);
      */
      //String filepath = "/home/scri97/users/cyoun/birch/GATEWAY/apache1.3.12/WWW/GOW/kitchen.vtk";

      //new AppletFrame(new App2kitchen(filepath),420,500);
    }

    public void testme ()
      {
      //System.out.println("Starting Render");
      }

    public void init()
      {

    //Connect to the master
    masterIOR=WebFlow.ClientUtils.getIORFromURL(urlfile);
    orb=WebFlow.ClientUtils.initializeORB(masterIOR,orb);
    master=WebFlow.ClientUtils.getMasterServer(masterIOR,orb);

    //Instatiate some webflow objects
    obj=WebFlow.ClientUtils.makeModule(master,"RemoteFile");
    rf=RemoteFileHelper.narrow(obj);
    rf.test();
    ftb = new FileTransferBean(rf);
    short blocksize = 10240;
    rf.setBlockSize(blocksize);

      GridBagLayout grid = new GridBagLayout();
      
      this.setLayout(grid);

      panel = new vtkPanel();
      panel.setSize(400,400);
      constrain(this,panel,0,0,8,8);

      FileInputStream is = null;
      try 
	{
	  //  I erase the differents non-usefull checkbok
 	//==========================================================================
	
	  /*
	CheckboxGroup cbg = new CheckboxGroup();
	constrain(this,new Checkbox("Mode 1",cbg,true),0,8,2,1);
	constrain(this,new Checkbox("Mode 2",cbg,false),2,8,2,1);
	constrain(this,new Checkbox("Mode 4",cbg,false),4,8,2,1);
	constrain(this,new Checkbox("Mode 8",cbg,false),6,8,2,1);
	constrain(this,new Checkbox("Scalar Coloring"),0,9,3,1);
	CheckboxGroup cbg2 = new CheckboxGroup();
	constrain(this,new Checkbox("Surface",cbg2,true),4,9,2,1);
	constrain(this,new Checkbox("Wireframe",cbg2,false),6,9,2,1);

	  */


	//==========================================================================
	  
	
	  //  *******************************************
	  //  HERE YOU HAVE TO CHANGE THE SOURCE
	  //*********************************************
          //mdname = "kitchen.vtk";
	
          //is = new FileInputStream(mdname);
          //md = new VTKModel(is);

          //mdname = "/home/scri97/users/cyoun/birch/GATEWAY/apache1.3.12/WWW/GOW/kitchen.vtk";

          /*
          mdname = filepath;
        byte buffer[] = null;
        String vtkdata = null;
        StringBuffer sb = new StringBuffer();

        try {
          rf.open(mdname,"r");
          buffer = rf.getBlock();
          String vtkdata1 = new String(buffer);
          sb.append(vtkdata1);

          while(true) {
            if(buffer.length > 0) {
              buffer = rf.getBlock();
              vtkdata1 = new String(buffer);
              sb.append(vtkdata1);
            }
            else throw new EOFFileException();
          }
        } catch(EOFFileException ex) {
          rf.close();
        }
        vtkdata = sb.toString();
        */

	// create the model
	//	pr = new vtkPolyDataReader();
	pr = new vtkStructuredGridReader();	
	//pr.ReadFromInputStringOn();
	//pr.SetInputString(md.GetData());
	//pr.SetInputString(vtkdata);
        
        ftb.FileReceive("C:\\kitchen.vtk",filepath);
	pr.SetFileName("C:\\kitchen.vtk");

	//***********************************************************
	// **********************************************************
	pr.Update();
	
	double range[] = new double[2];
	double maxVelocity,maxTime=0;
	if ( pr.GetOutput().GetPointData().GetScalars() != null )
	  {
	    range=pr.GetOutput().GetPointData().GetScalars().GetRange();
	  }
	if ( pr.GetOutput().GetPointData().GetVectors()!= null )
	  {
	    maxVelocity = pr.GetOutput().GetPointData().GetVectors().GetMaxNorm();
	    maxTime = 35.0*pr.GetOutput().GetLength()/maxVelocity ;
	  }
	
	
	vtkStructuredGridOutlineFilter outlineF = new vtkStructuredGridOutlineFilter();
	outlineF.SetInput(pr.GetOutput());
 
	vtkPolyDataMapper outlineMapper = new vtkPolyDataMapper();
	outlineMapper.SetInput(outlineF.GetOutput());
 
	vtkActor outline = new vtkActor();
	outline.SetMapper(outlineMapper);
	outline.GetProperty().SetColor(1,1,1);


	vtkStructuredGridGeometryFilter doorGeom = new vtkStructuredGridGeometryFilter();
	doorGeom.SetInput(pr.GetOutput());
	doorGeom.SetExtent(27,27,14,18,0,11);
	vtkPolyDataMapper mapDoor = new vtkPolyDataMapper();
	mapDoor.SetInput(doorGeom.GetOutput());
	mapDoor.ScalarVisibilityOff();
	vtkActor door = new vtkActor();
	door.SetMapper(mapDoor);
	door.GetProperty().SetColor(.59,.427,.3);
	

	vtkStructuredGridGeometryFilter window1Geom = new vtkStructuredGridGeometryFilter();
	window1Geom.SetInput(pr.GetOutput());
	window1Geom.SetExtent(0,0,9,18,6,12);
	vtkPolyDataMapper mapWindow1 = new vtkPolyDataMapper();
	mapWindow1.SetInput(window1Geom.GetOutput());
	mapWindow1.ScalarVisibilityOff();
	vtkActor window1 = new vtkActor();
	window1.SetMapper(mapWindow1);
	window1.GetProperty().SetColor(.3,.3,.5);
	
	vtkStructuredGridGeometryFilter window2Geom = new vtkStructuredGridGeometryFilter(); 
	window2Geom.SetInput(pr.GetOutput());
	window2Geom.SetExtent(5,12,23,23,6,12);
	vtkPolyDataMapper mapWindow2 = new vtkPolyDataMapper();
	mapWindow2.SetInput(window2Geom.GetOutput());
	mapWindow2.ScalarVisibilityOff();
	vtkActor window2 = new vtkActor();
	window2.SetMapper(mapWindow2);
	window2.GetProperty().SetColor(.3,.3,.5);
	
	vtkStructuredGridGeometryFilter klower1Geom = new vtkStructuredGridGeometryFilter();
	klower1Geom.SetInput(pr.GetOutput());
	klower1Geom.SetExtent(17,17,0,11,0,6);
	vtkPolyDataMapper mapKlower1 = new vtkPolyDataMapper();
	mapKlower1.SetInput(klower1Geom.GetOutput());
	mapKlower1.ScalarVisibilityOff();
	vtkActor klower1 = new vtkActor();
	klower1.SetMapper(mapKlower1);
	klower1.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter klower2Geom = new vtkStructuredGridGeometryFilter();
	klower2Geom.SetInput(pr.GetOutput());
	klower2Geom.SetExtent(19,19,0,11,0,6);
	vtkPolyDataMapper mapKlower2 = new vtkPolyDataMapper();
	mapKlower2.SetInput(klower2Geom.GetOutput());
	mapKlower2.ScalarVisibilityOff();
	vtkActor klower2 = new vtkActor();
	klower2.SetMapper(mapKlower2);
	klower2.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter klower3Geom = new vtkStructuredGridGeometryFilter();
	klower3Geom.SetInput(pr.GetOutput());
	klower3Geom.SetExtent(17,19,0,0,0,6);
	vtkPolyDataMapper mapKlower3 = new vtkPolyDataMapper();
	mapKlower3.SetInput(klower3Geom.GetOutput());
	mapKlower3.ScalarVisibilityOff();
	vtkActor klower3 = new vtkActor();
	klower3.SetMapper(mapKlower3);
	klower3.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter klower4Geom = new vtkStructuredGridGeometryFilter();
	klower4Geom.SetInput(pr.GetOutput());
	klower4Geom.SetExtent(17,19,11,11,0,6);
	vtkPolyDataMapper mapKlower4 = new vtkPolyDataMapper();
	mapKlower4.SetInput(klower4Geom.GetOutput());
	mapKlower4.ScalarVisibilityOff();
	vtkActor klower4 = new vtkActor();
	klower4.SetMapper(mapKlower4);
	klower4.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter klower5Geom = new vtkStructuredGridGeometryFilter();
	klower5Geom.SetInput(pr.GetOutput());
	klower5Geom.SetExtent(17,19,0,11,0,0);
	vtkPolyDataMapper mapKlower5 = new vtkPolyDataMapper();
	mapKlower5.SetInput(klower5Geom.GetOutput());
	mapKlower5.ScalarVisibilityOff();
	vtkActor klower5 = new vtkActor();
	klower5.SetMapper(mapKlower5);
	klower5.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter klower6Geom = new vtkStructuredGridGeometryFilter();
	klower6Geom.SetInput(pr.GetOutput());
	klower6Geom.SetExtent(17,19,0,7,6,6);
	vtkPolyDataMapper mapKlower6 = new vtkPolyDataMapper();
	mapKlower6.SetInput(klower6Geom.GetOutput());
	mapKlower6.ScalarVisibilityOff();
	vtkActor klower6 = new vtkActor();
	klower6.SetMapper(mapKlower6);
	klower6.GetProperty().SetColor(.8,.8,.6);

	vtkStructuredGridGeometryFilter klower7Geom = new vtkStructuredGridGeometryFilter();
	klower7Geom.SetInput(pr.GetOutput());
	klower7Geom.SetExtent(17,19,9,11,6,6);
	vtkPolyDataMapper mapKlower7 = new vtkPolyDataMapper();
	mapKlower7.SetInput(klower7Geom.GetOutput());
	mapKlower7.ScalarVisibilityOff();
	vtkActor klower7 = new vtkActor();
	klower7.SetMapper(mapKlower7);
	klower7.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter hood1Geom = new vtkStructuredGridGeometryFilter();
	hood1Geom.SetInput(pr.GetOutput());
	hood1Geom.SetExtent(17,17,0,11,11,16);
	vtkPolyDataMapper mapHood1 = new vtkPolyDataMapper();
	mapHood1.SetInput(hood1Geom.GetOutput());
	mapHood1.ScalarVisibilityOff();
	vtkActor hood1 = new vtkActor();
	hood1.SetMapper(mapHood1);
	hood1.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter hood2Geom = new vtkStructuredGridGeometryFilter();
	hood2Geom.SetInput(pr.GetOutput());
	hood2Geom.SetExtent(19,19,0,11,11,16);
	vtkPolyDataMapper mapHood2 = new vtkPolyDataMapper();
	mapHood2.SetInput(hood2Geom.GetOutput());
	mapHood2.ScalarVisibilityOff();
	vtkActor hood2 = new vtkActor();
	hood2.SetMapper(mapHood2);
	hood2.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter hood3Geom = new vtkStructuredGridGeometryFilter();
	hood3Geom.SetInput(pr.GetOutput());
	hood3Geom.SetExtent(17,19,0,0,11,16);
	vtkPolyDataMapper mapHood3 = new vtkPolyDataMapper();
	mapHood3.SetInput(hood3Geom.GetOutput());
	mapHood3.ScalarVisibilityOff();
	vtkActor hood3 = new vtkActor();
	hood3.SetMapper(mapHood3);
	hood3.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter hood4Geom = new vtkStructuredGridGeometryFilter();
	hood4Geom.SetInput(pr.GetOutput());
	hood4Geom.SetExtent(17,19,11,11,11,16);
	vtkPolyDataMapper mapHood4 = new vtkPolyDataMapper();
	mapHood4.SetInput(hood4Geom.GetOutput());
	mapHood4.ScalarVisibilityOff();
	vtkActor hood4 = new vtkActor();
	hood4.SetMapper(mapHood4);
	hood4.GetProperty().SetColor(.8,.8,.6);
	
	vtkStructuredGridGeometryFilter hood6Geom = new vtkStructuredGridGeometryFilter();
	hood6Geom.SetInput(pr.GetOutput());
	hood6Geom.SetExtent(17,19,0,11,16,16);
	vtkPolyDataMapper mapHood6 = new vtkPolyDataMapper();
	mapHood6.SetInput(hood6Geom.GetOutput());
	mapHood6.ScalarVisibilityOff();
	vtkActor hood6 = new vtkActor();
	hood6.SetMapper(mapHood6);
	hood6.GetProperty().SetColor(.8,.8,.6);

	vtkStructuredGridGeometryFilter cookingPlateGeom = new vtkStructuredGridGeometryFilter();
	cookingPlateGeom.SetInput(pr.GetOutput());
	cookingPlateGeom.SetExtent(17,19,7,9,6,6);
	vtkPolyDataMapper mapCookingPlate = new vtkPolyDataMapper();
	mapCookingPlate.SetInput(cookingPlateGeom.GetOutput());
	mapCookingPlate.ScalarVisibilityOff();
	vtkActor cookingPlate = new vtkActor();
	cookingPlate.SetMapper(mapCookingPlate);
	cookingPlate.GetProperty().SetColor(.9,.1,.1);
	
	vtkStructuredGridGeometryFilter filterGeom = new vtkStructuredGridGeometryFilter();
	filterGeom.SetInput(pr.GetOutput());
	filterGeom.SetExtent(17,19,7,9,11,11);
	vtkPolyDataMapper mapFilter = new vtkPolyDataMapper();
	mapFilter.SetInput(filterGeom.GetOutput());
	mapFilter.ScalarVisibilityOff();
	vtkActor filter = new vtkActor();
	filter.SetMapper(mapFilter);
	filter.GetProperty().SetColor(.8,.6,.6);
	
	

	//
	// regular streamlines
	//
	vtkLineSource line = new vtkLineSource();
	line.SetResolution(39);
	line.SetPoint1(0.08, 2.50, 0.71);
	line.SetPoint2(0.08, 4.50, 0.71);
	vtkPolyDataMapper rakeMapper = new vtkPolyDataMapper();
	rakeMapper.SetInput(line.GetOutput());
	vtkActor rake = new vtkActor();
	rake.SetMapper(rakeMapper);
	
	vtkRungeKutta4 integ = new vtkRungeKutta4();
	
	vtkStreamLine streamers = new vtkStreamLine();
	//streamers.DebugOn();
	streamers.SetInput(pr.GetOutput());
	streamers.SetSource(line.GetOutput());
	streamers.SetMaximumPropagationTime(maxTime);
	streamers.SetStepLength(maxTime/500.0);
	streamers.SetIntegrationStepLength(0.02);
	streamers.SetIntegrator(integ);
	streamers.Update();
	//streamers.DebugOff();
	
	vtkPolyDataMapper streamersMapper = new vtkPolyDataMapper();
	streamersMapper.SetInput(streamers.GetOutput());
	streamersMapper.SetScalarRange(range);
	//    streamersMapper.ScalarVisibilityOff();
	vtkActor lines = new vtkActor();
	lines.SetMapper(streamersMapper);
	lines.GetProperty().SetColor(0,0,0);
	
	panel.getRenderer().AddActor(outline);
	panel.getRenderer().AddActor(door);
	panel.getRenderer().AddActor(window1);
	panel.getRenderer().AddActor(window2);
	panel.getRenderer().AddActor(klower1);
	panel.getRenderer().AddActor(klower2);
	panel.getRenderer().AddActor(klower3);
	panel.getRenderer().AddActor(klower4);
	panel.getRenderer().AddActor(klower5);
	panel.getRenderer().AddActor(klower6);
	panel.getRenderer().AddActor(klower7);
	
	panel.getRenderer().AddActor(hood1);
	panel.getRenderer().AddActor(hood2);
	panel.getRenderer().AddActor(hood3);
	panel.getRenderer().AddActor(hood4);

	panel.getRenderer().AddActor(hood6);

	panel.getRenderer().AddActor(cookingPlate);
	panel.getRenderer().AddActor(filter);
	
	panel.getRenderer().AddActor(lines);
	panel.getRenderer().AddActor(rake);

	panel.getRenderer().SetStartRenderMethod(this,"testme");
	}
      catch(Exception e) 
	  {
	      e.printStackTrace();
	      md = null;
	      message = e.toString();
	  }
      try 
	  {
	      if (is != null) is.close();
	  } 
      catch(Exception e) 
	  {
	  }

      layout();	
      this.setBackground(new Color(120, 140, 160));
      show();
      }

    public void constrain(Container cont, Component comp,
                          int grid_x, int grid_y, 
                          int grid_width, int grid_height)
      {
      GridBagConstraints c = new GridBagConstraints();
      c.gridx = grid_x;
      c.gridy = grid_y;
      c.gridwidth = grid_width;
      c.gridheight = grid_height;
      c.anchor = GridBagConstraints.NORTH;

      ((GridBagLayout)cont.getLayout()).setConstraints(comp,c);
      cont.add(comp);
      }

    public boolean keyDown(Event e, int key) 
      {
      if (!super.keyDown(e,key))
        {
        return panel.keyDown(e,key);
        }
      return true;
      }

    public boolean action(Event evt, Object arg) 
      {
      if (arg instanceof Boolean) 
	  {
	  if (((Checkbox)evt.target).getLabel().equals("Mode 1")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      pr.SetVectorsName("mode1");
	      pr.Update();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Mode 2")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      pr.SetVectorsName("mode2");
	      pr.Update();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Mode 4")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      pr.SetVectorsName("mode4");
	      pr.Update();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Mode 8")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      pr.SetVectorsName("mode8");
	      pr.Update();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Scalar Coloring")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      plateMapper.ScalarVisibilityOn();
	      panel.Render();
	      }
	    else
	      {
	      plateMapper.ScalarVisibilityOff();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Surface")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      a.GetProperty().SetRepresentationToSurface();
	      panel.Render();
	      }
	    return true;
	    }
	  if (((Checkbox)evt.target).getLabel().equals("Wireframe")) 
	    {
	    if (((Boolean)arg).booleanValue())
	      {
	      a.GetProperty().SetRepresentationToWireframe();
	      panel.Render();
	      }
	    return true;
	    }
	  } 
	return super.action(evt, arg);
        }
}
