/**
 * Define the command for an item in the "Submit Job" menu.
 */

package WebFlow.ToolBar;
import WebFlow.submitJob.*;
import WebFlow.SerialHash.*;
import WebFlow.RemoteParse.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.lang.reflect.*;
import java.applet.*;

public class vtkCmd implements Command {
    
  String probName,probVal,dir;
  String urlstring;
  submitJob sj=null;
  SerialHash sh=null;
  RemoteParse rp=null;
  String appName,userName,command;
  Hashtable paramHash;
  AppletFrame vtkApplet; 

  Constructor[] constructors = null;
  Class vtkclass = null;
  Applet vtkobject = null;
   
  public vtkCmd(String probName,String urlstring,submitJob sj,SerialHash sh,RemoteParse rp,String dir) {
	this.probName=probName;
	//this.probVal=probVal;
        this.urlstring=urlstring;
	this.sj=sj;
	this.sh=sh;
        this.rp=rp;
	this.dir=dir;
    }
    public void Execute(){
      //sh.openHash(dir);
      //sh.deleteEntry(probName);
      //sh.closeHash();
      rp.init(dir,urlstring);
	
      //Take the probVal string and break it up into its components.
      //I'm assuming the order machine+userName+command.
      //StringTokenizer st=new StringTokenizer(probVal,"+");
      //machine=st.nextToken();
      //userName=st.nextToken();
      //command=st.nextToken();
      appName=rp.getJobParamValue(probName,"Machine");
      userName=rp.getJobParamValue(probName,"User");
      command=rp.getJobParamValue(probName,"Command");

      //rp.removeJob(probName);
      //rp.removeParseJobNode(probName);
      //rp.saveDocToFile();

      String app = "WebFlow.ToolBar."+appName;
      //vtkApplet= new AppletFrame(new App2kitchen(),"VTK Java Demo");
      try {
        vtkclass = Class.forName(app);  
        constructors = vtkclass.getConstructors();
        Object[] initArgs = {command};
        vtkobject = (Applet)constructors[0].newInstance(initArgs);
        vtkApplet= new AppletFrame(vtkobject,"VTK Java Demo");
        //vtkApplet.hide();
      } catch (ClassNotFoundException e) {
      } catch (java.lang.InstantiationException e) {
      } catch (IllegalAccessException e) {
      } catch (InvocationTargetException e) {}
      vtkApplet.show();
      vtkApplet.addWindowListener(new WindowAdapter() {
          public void windowClosing(WindowEvent e){
            vtkApplet.hide();
          }
        });
    }
}
